/*
   Questionnaire program by C.A.B.
   Version 2.0  October 1993
   Version 2.1  September 1994
   Version 2.2  July 1996.
   Part 2/3 (Shows the user all the answers)
   This program is in the public domain.
*/

#include "ckit.h"

#define number 20
#define no 0
#define yes 1
#define false 0
#define true 1
#define readindex 1
#define readsomeone 2
#define readnew 3
#define readall 4
#define quitprogram 5

int doorfile (char thename [], int *flag, int *screen, char com[], short *timeleft)
{                                         /* Returns 1 if standard door.sys  */
	FILE *f;                          /*   or dorinfo*.def is read.      */
	char temp[82];                    /* 2 if doorway's door.sys is read.*/
	char user[82];                    /* 0 if none of the above are read.*/
	int a;
	int b, port = 0;                   /* flag will be 1 for ansi.       */
					   /* screen = the screen length.    */
	*timeleft = 30;                    /* com = com0:, com1:, com2: etc. */
	strcpy(com,"com0:");               /* timeleft = minutes remaining.  */
	*screen = 23;                      /*  <-- those are the defaults    */
	*flag = false;                         /* thename is originally the filename, */
					   /* it returns the user's name.    */
	f = fopen(thename,"rt");
	if (f != NULL)
	{
	    if (stricmp(thename,"door.sys") == 0)
	    {
		fscanf(f,"%[^\n]",user);
		fscanf(f,"%i\n",&b);
		port = b;
		fscanf(f,"%i\n%i\n",&b,&b);
		*timeleft = b;
		strcpy(com,"COM");
		itoa(port,temp,10);
		strcat(com,temp);
		strcat(com,":");
		fscanf(f,"%s",temp);
		if (strnicmp(temp,"g",1) == 0 || strnicmp(temp,"m",1) == 0)
		{
			if(strnicmp(temp,"g",1) == 0)
				*flag = 1;
			fclose(f);
			strcpy(thename,user);
			return(2);
		}
		else
		{
			for  (a = 0; a < 4; a++)
				fscanf(f,"%s\n",temp);
			fscanf(f,"%[^\n]",user);
			getc(f);
			for  (a = 0; a < 4; a++)
			{
				fscanf(f,"%[^\n]",temp);
				getc(f);
			}
			for (a = 0; a < 2;a++)
				fscanf(f,"%i\n",&b);
			fgets(temp,82,f);
			fscanf(f,"%i\n%i\n",&b,&b);
			fscanf(f,"%[^\n]",temp);
			getc(f);
			if (strnicmp(temp,"G",1) == 0)
				*flag = 1;
			fscanf(f,"%i\n",&b);
			*screen = b;
			fclose(f);
			strcpy(thename,user);
			return(1);
		}
	    }
	    if (strnicmp(thename,"dorinfo",7) == 0)
	    {
		for (a = 0; a < 3; a++)
			fgets(temp,82,f);
		fscanf(f,"%[^\n]",temp);
		getc(f);
		fscanf(f,"%[^\n]",temp);
		getc(f);
		fscanf(f,"%i\n",&b);
		fscanf(f,"%[^\n]",user);
		getc(f);
		for (a = 0; a < 2; a++)
			fgets(temp,82,f);
		fscanf(f,"%i\n",&b);
		*flag = b;
		fclose(f);
		strcpy(thename,user);
		return(1);
	    }

	}
	fclose(f);
	return(0);

}

int asktheuser(int);
int printit(char [],int,int,int,int);
int pause();
void pausetwo();
void itell(char []);
void twotell(char [],char []);
void say(char []);
void shut_down();
void incaseof();
void fixname(char []);
void readinuserdate(char [], char []);
int compareusdate(char [], char []);

short       OPENED;          /* Flag to know if open_door has been called  */
short       CLOSED;          /* Flag to know if close_door has been called */

FILE *f;
int bad, quit, qcolour, acolour;
char answers[number] [82];
char progname[21];
					     /* Default questions*/
char questions [number] [82] =
{
"What's your real first name?\r\n",
"What's your real last name?\r\n",
"What's your address - number and street?\r\n",
"Suburb and state?\r\n",
"Your phone number?\r\n",
"What are your favourite hobbies?\r\n",
"Where did you hear about this BBS?\r\n",
"What do you do for a living?\r\n",
"What sort of computer do you have?\r\n"
};

char errors [10] [60] =
{
	"Successful\r\n",
	"Unable to open system file\r\n",
	"Problem reading BBS system file\r\n",
	"Unrecognized BBS file type\r\n",
	"Unable to open pcboard USERS file\r\n",
	"Invalid User record or problem seeking to user record\r\n",
	"Problem reading USER record\r\n",
	"PORT command syntax error\r\n",
	"Fossil driver/digiboard driver specified but not installed\r\n",
	"Memory allocation problem\r\n"
};

typedef struct ckgeneric
{
	char port[6];                   /* COM:?  */
	short min_left;                 /* minutes left */
};

struct ckitgeneric  ck_gen;

void main (int argc,char *argv[])
{

	int a,option,noofquestions,all, newanswers;
	int count, showindex,screen,flag, stop;
	char *ptr;
	char filename1 [82];
	char filename2 [82];
	char dateofans[82];
	char userlaston [82];
	char com[10];
	char temp[82];
	char temp2[82];
	char wolfie[82];

	OPENED = false;
	CLOSED = false;
	ck_FORCEOFFHOOK = FALSE;
	ck_NOSYSTEM = FALSE;
	ck_USERSFILE = FALSE;
	ck_NO_STATUS = TRUE;
	ck_logoff_color = (white);
	ck_NO_FKEYS = TRUE;
	count = 0;
	all = false;
	noofquestions = 8;
	a = option = bad = quit = false, newanswers = no;
	qcolour = 1;
	acolour = 2;
	strcpy(progname,"Quest 2.0");
	for (a = 9;a < number;a++)
		strcpy(questions[a],"undefined\r\n");

	for (a = 0;a < number;a++)
	     strcpy(answers[a],"-");
	strcpy(wolfie,"");
	strcpy(temp,"");
	strcpy(filename1,"question.dat");
	strcpy(filename2,"qanswer.dat");
	if (argc == 1)
	{
		puts("Error!  No dropfile specified on the command line.");
		exit(0);
	}
	if (argc > 2)         /* Using alternative filenames for question and answer files*/
	{
		a = 2;
		if (strnicmp(argv[2],"port",4) == 0)
		{
			strcpy(temp,argv[2]);
			a = 3;
		}

		if ( (a == 2 && argc == 4) || (a == 3 && argc == 5) )
		{
				strcpy(filename1,argv[a]);
				strcpy(filename2,argv[a + 1]);
		}

	}

	atexit(incaseof);
	strcpy(temp2,argv[1]);

	option = doorfile(temp2,&flag,&screen,ck_gen.port,&ck_gen.min_left);

	if (option == readsomeone)
	{
		ck_NOSYSTEM = TRUE;
		ptr = &ck_gen.port[0];
	}
	else
	{
		ptr = argv[1];
	}
	a = ck_open_door(ptr,temp);      /* Pass file name & PORT */
	OPENED = TRUE;
	if (a)
	{
		printf("Error! %s",errors[a]);
		shut_down();
	}
	if (option)
	{
		ck_graphics = flag;
		ck_page_length = screen;
		strcpy(ck_fullname,temp2);
	}
	else
		screen = ck_page_length;

	fixname(ck_fullname);
	f=fopen(filename1,"rt");       /* Reading in questions*/
	if (f)
	{
		noofquestions = 999;
		fscanf(f,"%i\n%i\n",&qcolour,&acolour);
		for (a = 0; a < number; a++)
		{
		     strcpy(temp,"");
		     fgets(temp,82,f);
		     if (strnicmp(temp,"Undef",5) == 0 && noofquestions == 999)
			       break;
		     strcpy(questions[a],temp);
		     if (strnicmp(questions[a],"Undef",5))
			     noofquestions = a;

		}
		if (noofquestions == 999)
		      noofquestions = 8;
	}
	fclose(f);
	readinuserdate(ck_fullname,userlaston);
	while (true)                           /* Main loop */
	{
		if(ck_DUMP_USER == TRUE)
			shut_down();

		showindex = all = count = stop = 0;
		ck_clr_screen();
		ck_color(white);
		puts("Questionnaire program by C.A.B.  This program is in the public domain.\n");
		strcpy(temp,"Hello ");
		strcat(temp,ck_fullname);
		strcat(temp,".\r\n");
		itell(temp);
		ck_newline();
		itell("You can:\r\n");
		itell("1  Look at the index\r\n");
		itell("2  Look at someone's answers\r\n");
		itell("3  Read all the new entries\r\n");
		itell("4  Read the whole book\r\n");
		itell("5  Quit\r\n");
		ck_newline();
		ck_color(dkred);
		itell("What do you want to do?  ");
		ck_color(white);
		option = asktheuser(quitprogram);
		ck_clr_screen();
		if ( option == quitprogram)
			 shut_down();
		bad = false;
		f = fopen(filename2,"rt");   /* Opening answer file */
		if (f == NULL)
		{
				fclose(f);
				itell("Nobody has answered the questionnaire yet.\r\n");
				ck_newline();
				pausetwo();
				continue;
		}
		rewind(f);
		if (option == readindex)            /* User only wants to see the index */
			showindex = true;
		if (option < readnew)             /* If looking up a user or looking at index */
		{
			while (true)           /* then go in a loop */
			{
				strcpy(wolfie,"");
				strcpy(temp,"");
				quit = false;
				bad = false;
				if (showindex == false)     /* If looking up someone */
				{

					ck_clr_screen();
					ck_color(white);
					itell("Who do you want to look up?  (Press enter to quit):  ");
					strcpy(wolfie,"");
					ck_get_cmdline();
					strcpy(wolfie,ck_cmdline);
					if (strcmp(wolfie,"") == 0)  /* Pressing enter to end */
						 break;
					ck_clr_screen();
				}
				else            /* If looking at index */
				{
					if (all == true)
					{
					    ck_newline();
					    break;
					}

					ck_color(white);
					itell("Index:");
					ck_newline();
					ck_newline();
				}
				rewind(f);
				while (true)     /* Checking the names in the file */
				{
					strcpy(dateofans,"");
					fgets(dateofans,80,f);         /* read date */
					if (strlen(dateofans) > 0)
					{
						fscanf(f,"%[^\n]",temp);    /* Read in a name */
						getc(f);

					}
					if (bad == true || strcmp(dateofans,"\n") == 0 || strcmp(dateofans,"") == 0 || strcmp(dateofans,"-") == 0)
					{                      /* End of file/corrupted file */
						if (showindex == false)
						{
							 ck_color(white);
							 ck_s_putv(wolfie,"'s answers aren't available.\r\n",NULL);
							 ck_newline();
							 pausetwo();

						}
						else
						{
							ck_newline();
							pausetwo();

						}
						all = true;
						quit = true;      /* Means that the name you wanted wasn't there*/
						break;
					}
					if (showindex == true)       /* Showing index */
					{

						  ck_color(white);
						  /* only show the name if it's checked or if it's the user's own name */
						  if (temp[0] != '' || (temp[0] == '' && strcmp(ck_fullname,&temp[1]) == 0))
						  {
							newanswers = compareusdate(dateofans,userlaston);
							if (newanswers == yes)
								itell("*");  /* Mark new entries */
							else
								itell(" ");
							if (temp[0] != '')
								itell(temp);      /* Show the name */
							else
								itell(&temp[1]);
							ck_newline();
							count ++;
						  }
						  if (count >= (screen - 4) )    /* Pause at end of each screenful */
						  {
							   count = 0;
							   ck_newline();
							   a = pause();
							   if (a)
							   {
								stop = true;
								break;
							   }
							   ck_clear_screen();

						  }
					}
					if (showindex == false && (strnicmp(temp,wolfie,strlen(wolfie)) == 0 || (temp[0] == '' && strcmp(wolfie,&temp[1]) == 0 && strcmp(wolfie,ck_fullname) == 0)) )
						  break;      /* Found the right name so break to show the answers */
					for (a = 0;a < number;a++)       /* Reading in other answers */
					{
					      if (bad == false)          /* from a non-corrupted answer file */
					      {
						      fgets(answers[a],82,f);
						      if(strcmp(answers[a],"") == 0)
							    bad = true;
					      }
					}

				}
				if (stop == true)    /* Means that the index was shown */
					break;
				if (quit == false)
				       a = printit(temp,noofquestions,screen,0,1);    /* read & show the answers  */
				ck_clr_screen();
			}
			fclose(f);
		}
		if (option == readnew || option == readall)        /* Reading all new answers */
		{                            /* or all answers */
			bad = false;
			a = 0;
			while (true)
			{
			       newanswers = no;
			       if (fgets(dateofans,80,f) == NULL)     /* read in date & check for EOF */
					break;
			       if (strncmp(dateofans,"-",1) == 0 )     /* corrupted file    */
					break;
			       fgets(temp,82,f);       /* Read in a name */
			       if (option == readnew)
			       {
					newanswers = compareusdate(dateofans,userlaston);  /*   newanswers will be yes for a new entry */
					if (newanswers == yes && (temp[0] != '' || strncmp(ck_fullname,&temp[1],strlen(ck_fullname)) == 0))
					{
						a = printit(temp,(number - 1),screen,1,yes);  /* Read & show the answers */
						ck_clr_screen();
					}
					else
						printit(temp,(number - 1),screen,1, no);
			       }
			       if (option == readall)
			       {
					if (temp[0] != '' || strncmp(ck_fullname,&temp[1],strlen(ck_fullname)) == 0)
						a = printit(temp,number-1,screen,1,yes);
					else
						a = printit(temp,(number - 1),screen,1, no);  /* Read & show the answers */
					ck_clr_screen();
			       }
			       if (a == true)      /* user wants to stop */
			       {
					break;
			       }
			}
			fclose(f);
		}
	}
}




int asktheuser(int e)
{
    int b;
    do
    {
		b = ck_wait_keypress();

    }  while ( (b < 49 || b > (48 + e) ) && b != TRUE && b != 13);
    if (b == TRUE)
	  shut_down();
    if (b == 13)
	  b = e;
    else
	  b -= 48;
    return(b);
}

int printit(char wolfie[],int howmanyanswers, int screen,int cont, int show)
{                              /* show = yes means show it else just read it */
	char temp[82];         /* returns 1 when the user wants to stop */
	int a,b,d,counter;
	counter = 0;
	d = 0;

	if (show == no)
	{
		for (a = 0;a <= howmanyanswers; a ++)
		{
			strcpy(temp,"");
			fgets(temp,81,f);   /* Read in answer */
			if(strcmp(temp,"") == 0)
			{
				 bad = 1;
				 break;
			}
		}

	}


	if (show == yes)
	{
	   ck_color(white);
	   if (wolfie[0] == '')
		itell(&wolfie[1]);
	   else
		itell(wolfie);
	   ck_newline();

	   for (a = 0;a <= howmanyanswers; a++)     /* howmanyanswers = number of answers it should read */
	   {
		  ck_color(qcolour);
		  itoa((a + 1),temp,10);
		  twotell(temp,"  ");
		  ck_s_putv(questions[a],"\r",NULL);

		  if (bad == 0)
		  {
			  fgets(answers[a],82,f);   /* Read in answer */
			  if(strcmp(answers[a],"") == 0)
				   bad = 1;
		  }
		  if (bad == 1)
			strcpy(answers[a],"-");
		  ck_color(acolour);
		  ck_s_putv(answers[a],"\r",NULL);
		  counter += 2;
		  if ((a == howmanyanswers || counter > (screen - 4) ) && cont == 0)
		  {                    /* Pause at end of screenful */
				counter = 0;
				ck_newline();
				pausetwo();
				ck_clr_screen();

		  }
		  if ( (a == howmanyanswers || counter > (screen - 4) ) && cont == 1)
		  {
				counter = 0;
				ck_newline();
				d = pause();
				ck_clr_screen();
				if (a != howmanyanswers && d == 1)
				      break;

		  }


	   }
	}
	return(d);       /* flag - does the user want to stop */
}

int pause ()
{
	     char temp [30];
	     int b;
	     b = 0;
	     strcpy(temp,"");

	     ck_color(dkred);
	      itell("Do you want to continue (Y/n)?  ");

	      ck_get_cmdline();

	      if (ck_DUMP_USER == TRUE)
		       shut_down();
	      if (strnicmp(ck_cmdline,"n",1) == 0)
			b = 1;

	      ck_clr_screen();
	      return(b);
}

void pausetwo()
{

	   ck_color(dkred);
	   itell("Press enter to continue.");
	   ck_get_cmdline();
	   ck_color(white);
	   ck_clr_screen();
	   if (ck_DUMP_USER == TRUE)
		shut_down();
}




void itell(char string [])
{
       say (string);

}


void twotell(char string1 [], char string2 [])
{
       say(string1);
       say(string2);
}

void say(char string [])
{
		ck_s_putstd(string);
}

void shut_down()
{

	if(OPENED && !CLOSED)
	{
		ck_close_door();
		CLOSED = TRUE;
	}
	exit(0);
}

void incaseof()
{

	if(OPENED && !CLOSED)
	{
		ck_close_door();
		CLOSED = TRUE;
	}

}

void fixname(char user[])
{
		int b, a;
		b = (strlen(user) - 1);
		if (user[b] == ' ')
		{
			for (a = b; a >= 0; a--)
			{
				if (user[a] != ' ')
					break;
				user[a] = '\0';
			}
		}
}

void readinuserdate(char username[],char userdate[])
{                             /* Find and change user's last date on */
	FILE *fp, *newfp;
	char nameread [82];
	char dateread [82];
	char todaysdate [82];
	int success = 0, quit = no, oldisthere = no, doneit = no;

	_strdate (todaysdate);
	strcpy (nameread,"");
	strcpy (dateread,"");
	strcpy (userdate,"01/01/80");

	remove ("oldqdate.dat");    /* oldqdates.dat shouldn't exist */
	oldisthere = rename("qdates.dat","oldqdate.dat");  /* check to see if qdates.dat exists */
	if (oldisthere != 0)          /* it it doesn't then create it */
	{
		newfp = fopen("qdates.dat","wt");
		fprintf(newfp,"%s\n%s\n",username,todaysdate);
		fclose(newfp);
	}
	else                          /* if it does then read it */
	{
		fp = fopen("oldqdate.dat","rt");
		newfp = fopen("qdates.dat","wt");

		while (quit == no)
		{
			success = fscanf(fp,"%[^\n]",nameread); /* read in a name */
			if (success != EOF)
			{
				getc(fp);
				success = fscanf(fp,"%[^\n]",dateread);  /* read in a date */
				if (success == EOF)     /* it shouldn't be at EOF, but just in case  */
					quit = yes;
				else
				{
					getc (fp);
					fprintf(newfp,"%s\n",nameread);
					if (stricmp(nameread,username) == 0)
					{
						doneit = yes;
						fprintf(newfp,"%s\n",todaysdate);
						strcpy(userdate,dateread);
					}
					else
						fprintf(newfp,"%s\n",dateread);
				}

			}
			else
				quit = yes;

		}
		if (doneit == no)      /* the user wasn't found in the data file */
		{
			fprintf(newfp,"%s\n",username);
			fprintf(newfp,"%s\n",todaysdate);
		}
		fclose(fp);
		fclose(newfp);
		remove("oldqdate.dat");
	}

}

int compareusdate(char dateread[], char userdate[])
{       /* For US style date strings:  mm/dd/yy    */
	/* Returns yes if dateread is newer than or equal to userdate */

	int monthread,dayread,yearread,usermonth,userday,useryear;
	int newanswers = no;

	monthread = atoi(dateread);
	dayread = atoi(&(dateread[3]));
	yearread = atoi(&(dateread[6]));

	usermonth = atoi(userdate);
	userday = atoi(&(userdate[3]));
	useryear = atoi (&(userdate[6]));

	if (useryear >= 94 && yearread < 94)          /* In case useryear >= 1994 and < 2000 */
		yearread += 1000;                     /* and yearread >= 2000          */
						      /* Works unless user last logged on in 1994 */
	if (yearread > useryear)                      /* and next logs on in 2094     */
		newanswers = yes;
	if (yearread == useryear)
	{
		if (monthread > usermonth)
			newanswers = yes;
		if (monthread == usermonth)
		{
			if (dayread >= userday)
				newanswers = yes;
		}

	}
	return(newanswers);


}

